/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmeingabe.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="STIMMEINGABE.Ergebniseingang",
     query="SELECT obj FROM Stimmeingabe obj WHERE obj.ergebniseingang = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

                
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STIMMEINGABE")
// @javax.persistence.IdClass(StimmeingabePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Inheritance(strategy = javax.persistence.InheritanceType.JOINED)
@javax.persistence.DiscriminatorColumn(name = "DISCRIMINATOR")
@javax.persistence.DiscriminatorValue(Stimmeingabe.DISCRIMINATOR_VALUE)

public
 class Stimmeingabe
extends AbstractStimmeingabe
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "STIMMEINGABE";

  /**
   * default constructor
   */
  public Stimmeingabe() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Stimmeingabe(Stimmeingabe original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "stimmeingabe_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Stimmeingabe")
    @javax.persistence.TableGenerator(name = "Stimmeingabe", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Stimmeingabe", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StimmeingabePK pkCache;

  @Override
  public StimmeingabePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StimmeingabePK(getId());
    }

    return pkCache;
  }

  public static <E extends Stimmeingabe> java.util.Map<StimmeingabePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StimmeingabePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Stimmeingabe> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedAnzahlEingabe = false;
          hasChangedDiscriminator = false;
          hasChangedStimmenart = false;
  
        hasChangedGruppeImGebiet = false;
        hasChangedListenkandidatur = false;
        hasChangedReferendumOption = false;
  

          hasChangedStimmeingabefehlersByStimmeingabe = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "ANZAHL_EINGABE", nullable = StimmeingabeConstants.ANZAHL_EINGABE_NULLABLE, length=StimmeingabeConstants.ANZAHL_EINGABE_MAX_LENGTH)
        
  protected java.lang.String anzahlEingabe =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAnzahlEingabe = false;

  public boolean hasChangedAnzahlEingabe(){
    return hasChangedAnzahlEingabe;
  }
  
  /**
   * 
   *
   * getter for STIMMEINGABE.ANZAHL_EINGABE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getAnzahlEingabe() {
        return anzahlEingabe;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE.ANZAHL_EINGABE
   *
   * @param anzahlEingabe
   */
  @Override   public void setAnzahlEingabe(@javax.annotation.Nullable  java.lang.String anzahlEingabe) {

       resetTkCache();
                  
                          java.lang.String anzahlEingabeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(anzahlEingabe, StimmeingabeConstants.ANZAHL_EINGABE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahlEingabe
      , anzahlEingabeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahlEingabe |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahlEingabe");
      }


      

       this.anzahlEingabe = anzahlEingabeInternal;

         }

        
  @javax.persistence.Column(name = "DISCRIMINATOR", nullable = StimmeingabeConstants.DISCRIMINATOR_NULLABLE, length=StimmeingabeConstants.DISCRIMINATOR_MAX_LENGTH)
        
  protected java.lang.String discriminator =  getInitialDiscriminator() ;

  @javax.persistence.Transient
  protected boolean hasChangedDiscriminator = false;

  public boolean hasChangedDiscriminator(){
    return hasChangedDiscriminator;
  }
  
  /**
   * Discriminator column for generalization
   *
   * getter for STIMMEINGABE.DISCRIMINATOR
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getDiscriminator() {
        return discriminator;
      }

  /**
   * Discriminator column for generalization
   *
   * setter for STIMMEINGABE.DISCRIMINATOR
   *
   * @param discriminator
   */
  @Override   public void setDiscriminator(@javax.annotation.Nullable  java.lang.String discriminator) {

       resetTkCache();
                  
                          java.lang.String discriminatorInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(discriminator, StimmeingabeConstants.DISCRIMINATOR_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.discriminator
      , discriminatorInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDiscriminator |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("discriminator");
      }


      

       this.discriminator = discriminatorInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STIMMENART", nullable = StimmeingabeConstants.STIMMENART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenart =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStimmenart = false;

  public boolean hasChangedStimmenart(){
    return hasChangedStimmenart;
  }
  
  /**
   * 
   *
   * getter for STIMMEINGABE.STIMMENART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.Stimmenart getStimmenart() {
        return stimmenart;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE.STIMMENART
   *
   * @param stimmenart
   */
  @Override   public void setStimmenart( de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenart) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenartInternal = stimmenart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stimmenart
      , stimmenartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStimmenart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("stimmenart");
      }


      

       this.stimmenart = stimmenartInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu GruppeImGebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GRUPPE_IM_GEBIET_ID", referencedColumnName="GRUPPE_IM_GEBIET_ID"))
  protected de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet gruppeImGebiet;

  /**
   * 
   */
  @Override
  public void setGruppeImGebiet( de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet gruppeImGebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gruppeImGebiet
    , gruppeImGebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGruppeImGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gruppeImGebiet");
    }

    this.gruppeImGebiet = gruppeImGebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet getGruppeImGebiet(){
    return this.gruppeImGebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGruppeImGebiet = false;

  public boolean hasChangedGruppeImGebiet(){
    return hasChangedGruppeImGebiet;
  }

  /**
   * Beziehung (unidirektional) zu Listenkandidatur
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "LISTENKANDIDATUR_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.kandidatur.entity.Listenkandidatur listenkandidatur;

  /**
   * 
   */
  @Override
  public void setListenkandidatur(@javax.annotation.Nullable  de.ivu.elect.business.kandidatur.entity.Listenkandidatur listenkandidatur){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.listenkandidatur
    , listenkandidatur);

    attributeChanged |= thisAttributChanged;

    hasChangedListenkandidatur |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("listenkandidatur");
    }

    this.listenkandidatur = listenkandidatur;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.kandidatur.entity.Listenkandidatur getListenkandidatur(){
    return this.listenkandidatur;
  }

  @javax.persistence.Transient
  protected boolean hasChangedListenkandidatur = false;

  public boolean hasChangedListenkandidatur(){
    return hasChangedListenkandidatur;
  }

  /**
   * Beziehung (unidirektional) zu ReferendumOption
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "REFERENDUM_OPTION_ID", referencedColumnName="WAHLVORSCHLAG_ID"))
  protected de.ivu.elect.business.wahlvorschlag.entity.ReferendumOption referendumOption;

  /**
   * 
   */
  @Override
  public void setReferendumOption(@javax.annotation.Nullable  de.ivu.elect.business.wahlvorschlag.entity.ReferendumOption referendumOption){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.referendumOption
    , referendumOption);

    attributeChanged |= thisAttributChanged;

    hasChangedReferendumOption |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("referendumOption");
    }

    this.referendumOption = referendumOption;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahlvorschlag.entity.ReferendumOption getReferendumOption(){
    return this.referendumOption;
  }

  @javax.persistence.Transient
  protected boolean hasChangedReferendumOption = false;

  public boolean hasChangedReferendumOption(){
    return hasChangedReferendumOption;
  }


/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu Ergebniseingang
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNISEINGANG_ID", referencedColumnName="ERGEBNISEINGANG_ID"))
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang;

  /**
   * 
   */
  @Override
  public void setErgebniseingang( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (ergebniseingang == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.ergebniseingang != null){
            this.ergebniseingang.removeStimmeingabeByErgebniseingang(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          ergebniseingang.addStimmeingabeByErgebniseingang(this);
        }
        this.ergebniseingang = ergebniseingang;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setErgebniseingangOhneUpdateBeziehung( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang ergebniseingang){
    resetTkCache();
        this.ergebniseingang = ergebniseingang;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.stimmeingabe.entity.Ergebniseingang getErgebniseingang(){
    return this.ergebniseingang;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu StimmeingabefehlersByStimmeingabe
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler.class, mappedBy="stimmeingabe", fetch=javax.persistence.FetchType.LAZY )
  protected java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler> stimmeingabefehlersByStimmeingabe;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler> getStimmeingabefehlersByStimmeingabe(){
    if (stimmeingabefehlersByStimmeingabe == null){
      return  java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler>unmodifiableSet(this.stimmeingabefehlersByStimmeingabe);
  }

  @javax.persistence.Transient
  private boolean hasChangedStimmeingabefehlersByStimmeingabe = false;

  public boolean hasChangedStimmeingabefehlersByStimmeingabe() {
    return hasChangedStimmeingabefehlersByStimmeingabe;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler
   */
  @Override
  public void addStimmeingabefehlerByStimmeingabe(de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler stimmeingabefehlerByStimmeingabe){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (stimmeingabefehlerByStimmeingabe != null){
          if (this.stimmeingabefehlersByStimmeingabe == null) {
            this.stimmeingabefehlersByStimmeingabe = new java.util.HashSet<>();
          }

          boolean isChanged = this.stimmeingabefehlersByStimmeingabe.add(stimmeingabefehlerByStimmeingabe);

          if(!hasChangedStimmeingabefehlersByStimmeingabe) {
            hasChangedStimmeingabefehlersByStimmeingabe =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          stimmeingabefehlerByStimmeingabe.setStimmeingabe(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler
   */
  @Override
  public void removeStimmeingabefehlerByStimmeingabe(de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler stimmeingabefehlerByStimmeingabe){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (stimmeingabefehlerByStimmeingabe != null){
          if (this.stimmeingabefehlersByStimmeingabe != null) {
            boolean isChanged = this.stimmeingabefehlersByStimmeingabe.remove(stimmeingabefehlerByStimmeingabe);

            if(!hasChangedStimmeingabefehlersByStimmeingabe) {
              hasChangedStimmeingabefehlersByStimmeingabe =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          stimmeingabefehlerByStimmeingabe.setStimmeingabe(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler
  */
   @Override
   public void removeAllStimmeingabefehlerByStimmeingabes(){
     java.util.Set<de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler> toRemove = new java.util.HashSet<>(getStimmeingabefehlersByStimmeingabe());

     for (   de.ivu.elect.business.stimmeingabe.entity.Stimmeingabefehler entity:toRemove){
       removeStimmeingabefehlerByStimmeingabe(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Stimmeingabe:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Stimmeingabe other){
                             other.anzahlEingabe = this.anzahlEingabe;
                                                  other.stimmenart = this.stimmenart;
           
  other.setErgebniseingang(this.getErgebniseingang());
  other.setGruppeImGebiet(this.getGruppeImGebiet());
  other.setListenkandidatur(this.getListenkandidatur());
  other.setReferendumOption(this.getReferendumOption());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Stimmeingabe.class)){
        copyEntityAttributesUsingSetter((Stimmeingabe) other.castTo(Stimmeingabe.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Stimmeingabe: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Stimmeingabe other){
               other.setAnzahlEingabe(this.anzahlEingabe);
                              other.setStimmenart(this.stimmenart);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Stimmeingabe other){
                       if (hasChangedAnzahlEingabe) {
        other.setAnzahlEingabe(this.anzahlEingabe);
      }
                                              if (hasChangedStimmenart) {
        other.setStimmenart(this.stimmenart);
      }
             }





    @javax.persistence.Transient
    private transient StimmeingabeTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StimmeingabeTK getStimmeingabeTK(){
    if (tkCache==null) {
    tkCache = new StimmeingabeTK(

getStimmenart()
,   (getGruppeImGebiet() == null) ? null : getGruppeImGebiet().getGruppeImGebietTK()
,   (getListenkandidatur() == null) ? null : getListenkandidatur().getListenkandidaturTK()
,   (getReferendumOption() == null) ? null : getReferendumOption().getReferendumOptionTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStimmeingabeTK();
    }

  @Override
  public StimmeingabeUK getUk(){
    return getStimmeingabeUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Stimmeingabe.class;
  }

public StimmeingabeUK getStimmeingabeUK(){

   return  new StimmeingabeUK(



  );
}

  @javax.persistence.Transient
  private transient StimmeingabeProperties properties;

  public StimmeingabeProperties getProperties(){
    if (properties == null) {
      properties = new StimmeingabeProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StimmeingabeProperties getStimmeingabeProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StimmeingabeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                        return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STIMMEINGABE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Stimmeingabe";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmeingabeConstants.ANZAHL_EINGABE_MAX_LENGTH ,  anzahlEingabe, this, StimmeingabeConstants.MESSAGE_KEY_ANZAHL_EINGABE_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmeingabeConstants.DISCRIMINATOR_MAX_LENGTH ,  discriminator, this, StimmeingabeConstants.MESSAGE_KEY_DISCRIMINATOR_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(stimmenart, this, StimmeingabeConstants.MESSAGE_KEY_STIMMENART_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
